{===================================================================================================

  Comming BASE

     ,    -.

====================================================================================================

  :

  26.06.2009 [*]   ToolBar2000.
  03.02.2005 [+]     (TPropStorageEh).
  01.02.2005 [+]       (HelpKeyword).
             [*]    (   -  
                   ).
  10.11.2004 [+]  .
  02.03.2004 [+] CloseModal:      .
  24.01.2004 [*]   .
  17.07.2003 [*]   "Circular unit reference".
  16.07.2003 [-]  uses.
             [*]     .
  06.04.2003 [*]    Tahoma.
  14.01.2003 [-]  uses.
  07.12.2002 [*]     .
  25.11.2002 [*]  Parent.
             [*]   Toolbar2000.
  11.10.2002 [-] .
  12.09.2002 [+] :     ""
  12.12.2001 [+]   AfterClose.
  08.12.2001 [+]   btExit -   .
  07.12.2001 [+]  .
  06.04.1999 [!]   BASE.

====================================================================================================
  Copyright 19992009 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEfrRootClient.pas,v 1.15 2010/05/04 06:48:53 tsk Exp $
===================================================================================================}
unit BASEfrRootClient;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComCtrls, ExtCtrls,
      ActnList, TB2Dock, TB2Toolbar, TB2Item, PropFilerEh, PropStorageEh,
      // Comming:
      CommingToolBar2000;

type

  TAfterClose = procedure of object;

  TBASERootClientFR = class(TFrame)
    pnBase: TPanel;
    alMain: TActionList;
    dcFrame: TTBDock;
    tbMain: TTBToolbar;
    imExit: TTBItem;
    imExecute: TTBSubmenuItem;
    spExit: TTBSeparatorItem;
    psRoot: TPropStorageEh;
    procedure imExitClick(Sender: TObject);
  private   { Private declarations }
    FCaption: String;
  public    { Public declarations }
    AfterClose: TAfterClose;
    constructor Create( AOwner: TComponent ); override;
    constructor CreateComming( AOwner: TComponent; APoc: TAfterClose );
    destructor  Destroy; override;
    procedure   ShowModal; virtual;
    procedure   CloseModal; virtual;
  end;

implementation

uses BASEfmRoot, BASEdmData;

{$R *.dfm}
//==================================================================================================
{ TBASERootClientFR }
//==================================================================================================
constructor TBASERootClientFR.Create( AOwner: TComponent );
begin
  inherited Create( AOwner );
  psRoot.Section := Copy( Name, 1, Length( Name ) - 2 );
  psRoot.LoadProperties;
  Name    := ClassName + IntToStr( Handle );
  Parent  := TWinControl( AOwner );
  TB2ExportMenu( imExecute, Application.MainForm.PopupMenu );
end;
//==================================================================================================
constructor TBASERootClientFR.CreateComming( AOwner: TComponent; APoc: TAfterClose );
begin
  inherited Create( AOwner );
  psRoot.Section := Copy( Name, 1, Length( Name ) - 2 );
  psRoot.LoadProperties;
  Name        := ClassName + IntToStr( Handle );
  Parent      := TWinControl( AOwner );
  AfterClose  := APoc;
  TB2ExportMenu( imExecute, Application.MainForm.PopupMenu );
end;
//==================================================================================================
destructor TBASERootClientFR.Destroy;
begin
  psRoot.SaveProperties;
  inherited;
end;
//==================================================================================================
procedure TBASERootClientFR.ShowModal;
begin
  with ( Owner as TBASERootFM) do begin
    dcMain.Visible := False;
    FCaption := Caption;
    if Length( Self.HelpKeyword ) > 0 then begin
      Caption := FCaption + '  ' + Self.HelpKeyword;
    end;
  end;
  Show;
  BringToFront;
end;
//==================================================================================================
procedure TBASERootClientFR.imExitClick(Sender: TObject);
begin
  CloseModal;
end;
//==================================================================================================
procedure TBASERootClientFR.CloseModal;
  var FV: Boolean;
      i: Integer;
begin
  Hide;
  //      .
  FV := True;
  with ( Owner as TBASERootFM) do begin
    for i := 0 to ComponentCount - 1 do
      if ( Components[i] is TBASERootClientFR ) and TBASERootClientFR(Components[i]).Visible then begin
        FV := False; Break;
      end;
    dcMain.Visible := FV;
    Caption := FCaption;
  end;
  Application.ProcessMessages;
  if Assigned( AfterClose ) then AfterClose;
end;
//==================================================================================================
end.
