{===================================================================================================

  Comming BASE

     . DBLookupCombo,         .

====================================================================================================

  :

  11.07.2009 [+]  .
  06.04.1999 [!]   BASE.

====================================================================================================
  Copyright 19992009 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEsfDBLookupComboLabel.pas,v 1.1 2009/07/13 05:21:29 tsk Exp $
===================================================================================================}
unit BASEsfDBLookupComboLabel;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, DB, Variants, StdCtrls,
      // Comming:
      CommingLookupFlat, CommingFlat;

type
  TBASEDBLookupComboLabelSF = class(TFrame)
    laField: TcoLabel;
    cbField: TcoDBLookupCombo;
  private   { Private declarations }
    FEnabled:   Boolean;
    FReadOnly:  Boolean;
    procedure   SetEnabledX( const Value: Boolean );
    procedure   SetReadOnly(const Value: Boolean);
    function    GetKeyValue: Integer;
  public    { Public declarations }
    procedure   RequeryLookup( Lookup: TDataSource = nil );
    property    Enabled: Boolean read FEnabled write SetEnabledX;
    property    ReadOnly: Boolean read FReadOnly write SetReadOnly;
    property    KeyValue: Integer read GetKeyValue;
  end;

implementation

{$R *.dfm}
//==================================================================================================
{ TBASEDBLookupComboSF }
//==================================================================================================
procedure TBASEDBLookupComboLabelSF.SetEnabledX( const Value: Boolean );
begin
  FEnabled          := Value;
  laField.Enabled   := Value;
  cbField.ReadOnly  := not Value;
  cbField.TabStop   := Value;
end;
//==================================================================================================
procedure TBASEDBLookupComboLabelSF.SetReadOnly( const Value: Boolean );
begin
  FReadOnly         := Value;
  cbField.ReadOnly  := Value;
  cbField.TabStop   := not Value;
end;
//==================================================================================================
procedure TBASEDBLookupComboLabelSF.RequeryLookup( Lookup: TDataSource = nil );
begin
  if cbField.LookupSource = nil then cbField.LookupSource := Lookup;
  if cbField.LookupSource <> nil then
    with cbField.LookupSource.DataSet do begin
      Close;
      Open;
    end;
end;
//==================================================================================================
function TBASEDBLookupComboLabelSF.GetKeyValue: Integer;
begin
  if cbField.KeyValue = null then Result := -1 else Result := cbField.KeyValue;
end;
//==================================================================================================
end.
